/* timer2_ovf
 * 
 * Egyerű mintapélda a Timer2 időzítő túlcsordulási
 * megszakításainak használatára. Az eredeti programot
 * egy "életjelző" LED villogtatásával kiegészítettük 
 * 
 * Az eredeti program szerzője: Roland Pelayo  
 * Link: https://www.teachmemicro.com/arduino-timer-interrupt-tutorial/
 * 
 */

#define ledPin LED_BUILTIN
const int heartbeat = 10;
volatile byte state = LOW;
 
void setup() {
   pinMode(ledPin, OUTPUT);
   pinMode(heartbeat, OUTPUT);   
   TIMSK2 = (TIMSK2 & B11111110) | 0x01;
   TCCR2B = (TCCR2B & B11111000) | 0x07;
}
 
void loop() {
   digitalWrite(heartbeat, LOW);
   delay(1000);
   digitalWrite(heartbeat, HIGH);
   delay(1000);
}
 
ISR(TIMER2_OVF_vect){
   state = !state;
   digitalWrite(ledPin, state);   
}
